import 'package:breaking_bad_quotes/core.dart';

/// When the request was canceled due to some error.
class RequestCancelException extends BreakingBadQuotesException {
  RequestCancelException([this.additionalData])
      : super(
          Constants.requestCancelled,
        );

  final dynamic additionalData;
}

/// When unable to complete the request
class RequestFailureException extends BreakingBadQuotesException {
  RequestFailureException(this.response)
      : super(
          Constants.requestFailure,
        );

  final IResponse response;
}

/// When some other exception has occurred which is unknown.
class RequestOtherException extends BreakingBadQuotesException {
  RequestOtherException([this.additionalData])
      : super(
          '${Constants.requestFailed} ($additionalData)',
        );

  final dynamic additionalData;
}

/// When the request timeout exception has occurred
class RequestTimeoutException extends BreakingBadQuotesException {
  RequestTimeoutException([this.additionalData])
      : super(
          Constants.requestTimeout,
        );

  final dynamic additionalData;
}
