// coverage:ignore-file
import 'dart:convert';

import 'package:breaking_bad_quotes/core.dart';

List<Results> resultsFromMap(List<dynamic> str) => List<Results>.from(
      str.map<dynamic>(
        (dynamic x) => Results.fromMap(
          x as Map<String, dynamic>,
        ),
      ),
    );

String resultsToMap(List<Results> data) => json.encode(
      List<Map<String, dynamic>>.from(
        data.map<Map<String, dynamic>>(
          (x) => x.toMap(),
        ),
      ),
    );

class Results extends Result {
  Results({
    required this.quote,
    required this.author,
  });

  factory Results.fromMap(Map<String, dynamic> json) => Results(
        quote: json['quote'] as String? ??
            'I am not in danger, Skyler. I AM the danger!',
        author: json['author'] as String? ?? 'Walter White',
      );

  String quote;
  String author;

  Map<String, dynamic> toMap() => <String, dynamic>{
        'quote': quote,
        'author': author,
      };
}
