// coverage:ignore-file
import 'package:breaking_bad_quotes/core.dart';

/// A parameter class which will be used to get a single quote from
/// Breaking Bad.
///
/// [numberOfQuotes] : Number of quotes needed. If needed only 1 then no need
/// to set this value.
class QuotesParams extends Parameters {
  QuotesParams({
    this.numberOfQuotes = 1,
  });

  int numberOfQuotes;

  @override
  Request toRequest() => Request.get(
        uri: Uri(
          path: '/v1/quotes/$numberOfQuotes',
        ),
      );
}
